scheduler.initCustomLightbox = function (obj) {
    scheduler.config.buttons_left = [];
    scheduler.config.buttons_right = [];
    scheduler._getLightbox = scheduler.getLightbox;
    scheduler.config.lightbox.sections = [{ type: 'frame', name: 'box'}];
    scheduler._cust_date_to_str = scheduler.date.str_to_date("%m/%d/%Y %H:%i");

    if (obj.type == "external") {
        scheduler.getLightbox = function () {
            if (!scheduler._lightbox) {
                var box = scheduler._getLightbox();
                var area = box.childNodes[1];
                if (area.firstChild.className == 'dhx_cal_lsection')
                    area.firstChild.style.display = 'none';
                area.style.height = area.style.height.replace('px', '') - 25 + 'px';
                box.style.height = box.style.height.replace('px', '') - 50 + 'px';
                box.style.width = (+obj.width + 10) + 'px';
                area.style.width = obj.width + 'px';
            }
            scheduler._custom_box_stage = 0;
            return scheduler._lightbox;
        };

        scheduler._setLightboxValues = function (frame, id) {
            var frame = document.getElementById("scheduler_here_iframe_");
            try {
                switch (scheduler._custom_box_stage) {
                    case (0):


                        if (!window.dp) {
                            var dp = new DataProcessor();
                            dp.init(scheduler);
                        }
                        var dp = window.dp || dp;
                        var ev = dp._getRowData(id);
                        var form = '<form action=\'/' + obj.view + '?id=' + encodeURIComponent(id) + '\' method=\'POST\'>';
                        for (var i in ev) {
                            form += '<input type=\'hidden\' name=\'' + i + '\'/>';
                        }

                        form += '</form>';

                        if (!frame.Document)
                            var frameBody = frame.contentDocument.body;
                        else
                            var frameBody = frame.Document.body;
                        frameBody.innerHTML = form;
                        var count = 0;
                        for (var i in ev) {
                            frameBody.firstChild.childNodes[count++].value = ev[i];
                        }
                        frameBody.firstChild.submit();
                        break;
                    case (1):



                        if (!frame.contentWindow.lightbox) {
                            var winobj = frame.contentWindow;
                            frame.contentWindow.lightbox = {
                                close: function () {
                                    scheduler._remove_customBox();
                                }

                            };
                        }
                        scheduler.callEvent('onLightbox', [id]);
                        break;
                    case (2):
                        if (!frame)
                            return;
                        if (!frame.Document)
                            var frameBody = frame.contentDocument.body;
                        else
                            var frameBody = frame.Document.body;
                        scheduler._doLAction(frameBody.textContent || frameBody.innerText);
                        scheduler._remove_customBox();
                        break;
                }
            } catch (e) {
                scheduler._remove_customBox();
                if (window.console)
                    console.log(e);
            }
            scheduler._custom_box_stage++;

        };
        scheduler._remove_customBox = function () {
            if (scheduler._lightbox)
                scheduler.endLightbox(false, scheduler._lightbox);
            else
                scheduler.endLightbox(false);
        };
        scheduler._doLAction = function (data) {
            try {
                eval("scheduler.parsed_result_d = " + data + ";");
                var item = scheduler.parsed_result_d;
                delete scheduler.parsed_result_d;


                if (!item)
                    return;

                var updatedEvent = item.data;
                if (updatedEvent.start_date && updatedEvent.end_date) {
                    updatedEvent.start_date = scheduler._cust_date_to_str(item.data.start_date);
                    updatedEvent.end_date = scheduler._cust_date_to_str(item.data.end_date);
                }


                switch (item.action) {
                    case "insert":
                        scheduler._loading = true;
                        scheduler.addEvent(updatedEvent);

                        scheduler._loading = false;
                        break;
                    case "update":
                        var oldEvent = scheduler.getEvent(item.sid);

                        for (var i in updatedEvent) {
                            oldEvent[i] = updatedEvent[i];
                        }
                        scheduler.event_updated(oldEvent);

                        break;
                    case "delete":
                        scheduler.deleteEvent(item.sid, true);
                        break;
                    default:
                        break;
                }
            } catch (e) { }
        };
        scheduler.form_blocks['frame'] = {
            render: function (sns) {
                return '<div style=\'display:inline-block; height:' + obj.height + 'px\'></div>';
            },
            set_value: function (node, value, ev) {
                scheduler._last_id = ev.id;

                var html = '<iframe id="scheduler_here_iframe_" frameborder=\'0\' onload=\'scheduler._setLightboxValues(this, scheduler._last_id)\' src=\'\'';

                if (obj.width || obj.height)
                    html += ' style=\'';
                if (obj.width) {
                    html += 'width:' + obj.width + 'px;';
                    node.style.width = obj.width + 'px';
                }
                if (obj.height) {
                    html += 'height:' + obj.height + 'px;';
                    node.style.height = obj.height + 'px';
                }
                if (obj.width || obj.height)
                    html += ' \'';
                html += '><html></html></iframe>';

                node.innerHTML = html;
                if (obj.classname)
                    node.className = obj.classname;

                return true;
            },
            get_value: function (node, ev) {
                return true;
            },
            focus: function (node) {
                return true;
            }
        };
        scheduler._addEventFromFrame = function (ev) {
            var sched_ev = {};
        }
    } else {
        scheduler.form_blocks['frame'] = {
            render: function (sns) {
                var res = '<iframe  id="scheduler_here_iframe_" onload=\'scheduler._addLightboxInterface(this)\' frameborder=\'0\' src=\'' + obj.view + '\'';
                if (obj.width || obj.height)
                    res += ' style=\'';
                if (obj.width)
                    res += 'width:' + obj.width + 'px;';
                if (obj.height)
                    res += 'height:' + obj.height + 'px;';
                if (obj.width || obj.height)
                    res += ' \'';
                res += ' ></iframe>';
                return res;
            },
            set_value: function (node, value, ev) {
                if (node.contentWindow && node.contentWindow.setValues) {

                    if (node.contentWindow.document.getElementsByTagName('form').length == 1) {
                        node.contentWindow.document.getElementsByTagName('form')[0].reset();
                    }
                    else {
                        var ev = node.contentWindow.getValues();
                        for (var i in ev)
                            ev[i] = '';
                        node.contentWindow.setValues(ev);
                    }

                    node.contentWindow.setValues(ev);
                }
            },
            get_value: function (node, ev) {
                return scheduler._deep_copy(node.contentWindow.getValues());
            },
            focus: function (node) {
                return true;
            }
        };

        scheduler.getLightbox = function () {
            if (!scheduler._lightbox) {
                var box = scheduler._getLightbox();
                var area = box.childNodes[1];
                if (area.firstChild.className == 'dhx_cal_lsection')
                    area.firstChild.style.display = 'none';
                area.style.height = area.style.height.replace('px', '') - 25 + 'px';
                box.style.height = box.style.height.replace('px', '') - 50 + 'px';
                box.style.width = (+obj.width + 10) + 'px';
                area.style.width = obj.width + 'px';
            }

            return scheduler._lightbox;
        };

        scheduler._addLightboxInterface = function (frame) {
            if (!frame.contentWindow.lightbox)
                frame.contentWindow.lightbox = {};

            frame.contentWindow.lightbox.save = function () {
                var ev = scheduler.getEvent(scheduler.getState().lightbox_id);
                var changed = frame.contentWindow.getValues();
                for (var i in changed) {
                    ev[i] = changed[i];
                }
                scheduler.endLightbox(true, scheduler._lightbox);
            };
            frame.contentWindow.lightbox.close = function (argument) {
                scheduler.endLightbox(false, scheduler._lightbox);

            };
            frame.contentWindow.lightbox.remove = function () {
                var c = scheduler.locale.labels.confirm_deleting;
                if (!c || confirm(c)) {
                    scheduler.deleteEvent(scheduler._lightbox_id);
                    scheduler._new_event = null;

                }
                scheduler.endLightbox(true, scheduler._lightbox);
            };


            if (frame.contentWindow.document.getElementsByTagName('form').length == 1) {
                frame.contentWindow.document.getElementsByTagName('form')[0].reset();
            }
            else {
                var ev = frame.contentWindow.getValues();
                for (var i in ev)
                    ev[i] = '';
                frame.contentWindow.setValues(ev);
            }
            frame.contentWindow.setValues(scheduler.getEvent(scheduler._lightbox_id));
            scheduler.callEvent('onLightbox', [scheduler._lightbox_id]);
        };
    };
};
